const int TE_LOW = 390;
const int TE_HIGH = 823 - TE_LOW;
const int DALI_TX = 8;

void setup() {
  pinMode(DALI_TX, OUTPUT);
  digitalWrite(DALI_TX, LOW);
  Serial.begin(115200);
  while (!Serial) ;
  Serial.println("DALI Interface Ready");
}

void loop() {      
  uint8_t cbyte1 = 0;
  uint8_t cbyte2 = 0;
  uint8_t dimval = 0;
  Serial.println("Command: ");
  while(Serial.available()<2) {
  }
  cbyte1=Serial.read();
  cbyte2=Serial.read();
  cbyte1=hex2dec(cbyte1);
  cbyte2=hex2dec(cbyte2);
  dimval=cbyte1*16+cbyte2;
  sendCommand(0xFE, dimval);
  Serial.print("Set dimming value to ");
  Serial.print(dimval,DEC);
  Serial.println(" OK!");
}

void sendCommand(uint8_t cmd1, uint8_t cmd2) {
  sendBit(1);
  sendByte(cmd1);
  sendByte(cmd2);
  txHigh();
  delay(10); 
}

void sendByte(uint8_t b) {
  for (int i = 7; i >= 0; i--) {
    sendBit((b >> i)  & 1);
  }
} 

void sendBit(int b) {
   if (b) {
     txLow();
     delayMicroseconds(TE_LOW);
     txHigh();
     delayMicroseconds(TE_HIGH);
   } else {
     txHigh();
     delayMicroseconds(TE_HIGH);
     txLow();
     delayMicroseconds(TE_LOW);
   }
}

void txHigh() {
  digitalWrite(DALI_TX, LOW);
}
void txLow() {
  digitalWrite(DALI_TX, HIGH);
}

char hex2dec (char input) {
  if(input >= '0' && input <= '9') {
    input = input - '0';
  } else if (input >='a' && input <= 'f') {
    input = input - 'a';
    input = input + 10;
  } else if (input >='A' && input <= 'F') {
    input = input - 'A';
    input = input + 10;
  } else {
    input = 15;
  }
  return(input);
}
